/*  BotikBalance - User's account balance informer for Botik Network 
 *                 for Windows 9x/ME/NT/2000/XP/2003
 *  Copyright (C) 2005 Alexander V. Melnikoff
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public Licensse as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/* Sorry for the long lines in the sources, I have wide screen... ;-)
 */

#ifndef __DATACONT_H__
#define __DATACONT_H__

#include <map>
#include <string>
using namespace std;

class CDataCont
{
public:
	CDataCont(void);
	~CDataCont(void);

public:
	static CDataCont* CreateObject();

	LPTSTR GetAccount(VOID) {return(m_szAccount);};
	LPTSTR GetUser(VOID) {return(m_szUser);};
	LPTSTR GetPassword(VOID) {return(m_szPassword);};

	VOID SetAccount(LPTSTR szNew_);
	VOID SetUser(LPTSTR szNew_);
	VOID SetPassword(LPTSTR szNew_);

	VOID SetUseProxy(BOOL fUse_);
	BOOL GetUseProxy(VOID) {return(m_fUseProxy);};

	VOID SetProxyServer(LPTSTR szNew_);
	LPTSTR GetProxyServer(VOID) {return(m_szProxyServer);};

	VOID SetData(LPTSTR szName_, LPTSTR szVal_);
	LPTSTR GetData(LPTSTR szName_);

private:
	typedef map<string, string> STR2STRMAP;
	typedef STR2STRMAP::iterator STR2STRMAPIT;

private:
	CRITICAL_SECTION	m_csDataCont;

	LPTSTR		m_szAccount;
	LPTSTR		m_szUser;
	LPTSTR		m_szPassword;

	LPTSTR		m_szProxyServer;
	BOOL		m_fUseProxy;

	STR2STRMAP	m_mapDataCont;
};

#endif // __DATACONT_H__