/*  build-inc - Build incrementation utility for MS Visual Studio .NET 7.1
 *              it is probably compatible to old versions of MS VS.
 *
 *  Copyright (C) 2004 Alexander V. Melnikoff
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public Licensse as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

var objRscFileNames = new Array();
var strCfgFileName = "";
var strInstFileName = "";
var objConfig = new Array();
var fQuite = 0;

main();

function main()
{
	// Read and process arguments.
	var i = 0;
	var objArgs = WScript.Arguments;
	while(i < objArgs.length)
	{
		if(objArgs(i) == "-r")
		{
			objRscFileNames[objRscFileNames.length] = objArgs(i+1);
			i+=2;
		}
		else if(objArgs(i) == "-q")
		{
			fQuite = 1;
			i++;
		}
		else if(objArgs(i) == "-c")
		{
			strCfgFileName = objArgs(i+1);
			i+=2;
		}
		else if(objArgs(i) == "-s")
		{
			strInstFileName = objArgs(i+1);
			i+=2;
		};
	};

	// Show files.
	//if(!fQuite)
	//	WScript.Echo("Script file name:   "+strInstFileName+"\n"+
	//				 "Config file name:   "+strCfgFileName);

	// Read config file.
	if(strCfgFileName == "")
	{
		WScript.Echo("You don't specify configuration file.");
		
		return;
	};

	ReadConfig(); // Read config.

	// Check configuration.
	var key, nLen = 0;
	for(key in objConfig) // Count number of elements.
		nLen++;

	if(nLen == 6)
	{
		// If we have specified resource files, update them.
		if(objRscFileNames.length > 0)
		{
			for(i = 0; i < objRscFileNames.length; i++)
			{
				UpdateResources(objRscFileNames[i]);
			};
		};
		
		// If we have specified script file, update it.
		if(strInstFileName != "")
		{
			UpdateInstScript(strInstFileName);
		};

		if(!fQuite)
			WScript.Echo("Version successfuly incremented.\n"+
			             "MS Visual Studio IDE will prompt you to reload resource(s) file(s).\n"+
			             "You can configure IDE to autoload changed files.");
	};
}; // main()

function UpdateResources(strFileName_)
{
	var fl, text, ver, re, st;
	var fso = WScript.CreateObject("Scripting.FileSystemObject");

	fso.CopyFile(strFileName_, strFileName_+".bak", true); // Make backup.

	fl = fso.OpenTextFile(strFileName_, 1);
	text = new String(fl.ReadAll());
	fl.Close();

	ver = objConfig["VERSION"].replace(".", ",").replace(".", ",");;

	// Increment and replace build counter of FILEVERSION variable.
	re = new RegExp("^ FILEVERSION ([0-9]*),([0-9]*),([0-9]*),([0-9]*)$", "mg");
	if((st = re.exec(text)));
	{
		st[4]++;
		text = text.replace(re, " FILEVERSION "+ver+","+st[4]);
	};

	// Replace build counter of PRODUCTVERSION variable for the new one.
	re = new RegExp("^ PRODUCTVERSION ([0-9]*),([0-9]*),([0-9]*),([0-9]*)$", "mg");
	text = text.replace(re, " PRODUCTVERSION "+ver+","+objConfig["BUILD"]);

	ver = objConfig["VERSION"].replace(".", ", ").replace(".", ", ");

	// Increment and replace build counter of FileVersion variable in the 
	// languages block headers.
	re = new RegExp("^            VALUE \"FileVersion\", \"([0-9]*), ([0-9]*), ([0-9]*), ([0-9]*)\"$", "mg");
	while((st = re.exec(text)))
	{
		st[4]++;
		text = text.replace(re, "            VALUE \"FileVersion\", \""+ver+", "+st[4]+"\"");
	};

	// Replace build counter of ProductVersion variable in the 
	// languages block headers for the new one.
	re = new RegExp("^            VALUE \"ProductVersion\", \"([0-9]*), ([0-9]*), ([0-9]*), ([0-9]*)\"$", "mg");
	while((st = re.exec(text)))
	{
		text = text.replace(re, "            VALUE \"ProductVersion\", \""+ver+", "+objConfig["BUILD"]+"\"");
	};

	// Update about title string.
	if(objConfig["ABOUTTITLESTRING"] != "")
	{
		var objDate = new Date();
		var strBuildDate = objDate.getFullYear()+
						""+(objDate.getMonth() < 10 ? "0"+(objDate.getMonth()+1) : (objDate.getMonth()+1))+
						""+(objDate.getDate() < 10 ? "0"+(objDate.getDate()) : (objDate.getDate()))+
						""+(objDate.getHours() < 10 ? "0"+(objDate.getHours()) : (objDate.getHours()))+
						""+(objDate.getMinutes() < 10 ? "0"+(objDate.getMinutes()) : (objDate.getMinutes()))+
						""+(objDate.getSeconds() < 10 ? "0"+(objDate.getSeconds()) : (objDate.getSeconds()));

		var strAboutTitle = objConfig["ABOUTTITLEFORMAT"];
		strAboutTitle = strAboutTitle.replace("%APPNAME%", objConfig["APPNAME"]);
		strAboutTitle = strAboutTitle.replace("%VERSION%", objConfig["VERSION"]);
		strAboutTitle = strAboutTitle.replace("%BUILD%", objConfig["BUILD"]);
		strAboutTitle = strAboutTitle.replace("%VERSUFFIX%", objConfig["VERSUFFIX"]);
		strAboutTitle = strAboutTitle.replace("%BUILDDATE%", strBuildDate);

		re = new RegExp("^([^A-Za-z0-9]*)"+objConfig["ABOUTTITLESTRING"]+"([^\"]*)\"[^\"]*\"$", "mg");

		while((st = re.exec(text)))
		{
			text = text.replace(re, st[1]+objConfig["ABOUTTITLESTRING"]+st[2]+"\""+strAboutTitle+"\"");
		};
	};

	// Save file.
	fl = fso.OpenTextFile(strFileName_, 2);
	fl.Write(text);
	fl.Close();
};

function UpdateInstScript(strFileName_)
{
	var fl, text, re;
	var fso = WScript.CreateObject("Scripting.FileSystemObject");
	
	fso.CopyFile(strFileName_, strFileName_+".bak", true); // Make backup.
	
	fl = fso.OpenTextFile(strFileName_, 1);
	text = new String(fl.ReadAll());
	fl.Close();
			
	re = new RegExp("^!define PRODUCT_VERSION \"[^\"]*\"$", "mg");
	text = text.replace(re, "!define PRODUCT_VERSION \""+objConfig["VERSION"]+"."+objConfig["BUILD"]+objConfig["VERSUFFIX"]+"\"");
			
	// Save script.
	fl = fso.OpenTextFile(strFileName_, 2);
	fl.Write(text);
	fl.Close();
};

function ReadConfig()
{
	var fso = WScript.CreateObject("Scripting.FileSystemObject");
	var fl, re, st, text;
	
	fl = fso.OpenTextFile(strCfgFileName, 1);
	text = new String(fl.ReadAll());
	fl.Close();
	
	re = /^([A-Z]*)=\"([^\"]*)\"$/mg;

	while((st = re.exec(text)))
	{
		objConfig[st[1]] = st[2];
	};
	
	objConfig["BUILD"]++;
	
	// Save file with new (updated) data.
	fl = fso.OpenTextFile(strCfgFileName, 2);
	for(key in objConfig)
		fl.WriteLine(key+"=\""+objConfig[key]+"\"");
	fl.Close();
};
